Can't create instances with flavors that have "numa" related extra specs in a cell setup (cells v1)

Bug #1517006 reported by Belmiro Moreira on 2015-11-17
32
This bug affects 6 people
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
Wishlist
Unassigned

Bug Description

In a cell setup can't create instances with flavors that have extra specs like:
hw:numa_nodes
hw:mem_page_size

nova-cell in the "child cell" fails with:

2015-11-17 10:51:50.574 ERROR nova.cells.scheduler [req-f7dc64e6-a545-4c2c-bc57-4e4a2e86cf58 demo demo] Couldn't communicate with cell 'cell'
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler Traceback (most recent call last):
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler File "/opt/stack/nova/nova/cells/scheduler.py", line 186, in _build_instances
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler image, security_groups, block_device_mapping)
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler File "/opt/stack/nova/nova/cells/scheduler.py", line 109, in _create_instances_here
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler instance.update(instance_values)
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler File "/usr/local/lib/python2.7/dist-packages/oslo_versionedobjects/base.py", line 727, in update
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler setattr(self, key, value)
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler File "/usr/local/lib/python2.7/dist-packages/oslo_versionedobjects/base.py", line 71, in setter
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler field_value = field.coerce(self, name, value)
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler File "/usr/local/lib/python2.7/dist-packages/oslo_versionedobjects/fields.py", line 189, in coerce
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler return self._type.coerce(obj, attr, value)
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler File "/usr/local/lib/python2.7/dist-packages/oslo_versionedobjects/fields.py", line 506, in coerce
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler 'valtype': obj_name})
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler ValueError: An object of type InstanceNUMATopology is required in field numa_topology, not a
2015-11-17 10:51:50.574 TRACE nova.cells.scheduler
2015-11-17 10:51:50.574 ERROR nova.cells.scheduler [req-f7dc64e6-a545-4c2c-bc57-4e4a2e86cf58 demo demo] Couldn't communicate with any cells

Reproduce steps:
1) Setup nova in order to use cells.

2) Create a flavor with the extra spec "hw:numa_nodes"
nova flavor-create m1.nano.numa2 30 64 1 1
nova flavor-key 30 set hw:numa_nodes=1

3) Create an instance with the new flavor

Actual Result:
Instance status: ERROR
Instance task state: scheduling

Trace in "child cell".

Tested in devstack (master).
Tested in Kilo.

sirswa (sirswa) wrote :

I am having the same issue. But I think the issue is NUMA rather than extra spec.

I have other flavors with extra spec (pci_passthrough) and they have no issue.
Only issue when I set "hw:numa_nodes"

Indeed, considering the trace:
"An object of type InstanceNUMATopology is required in field numa_topology"

 I'm editing the bug title to better reflect the bug.

summary: - Can't create instances with flavors that have extra specs in a cell
- setup
+ Can't create instances with flavors that have "numa" related extra specs
+ in a cell setup
melanie witt (melwitt) on 2015-11-19
Changed in nova:
importance: Undecided → Medium
status: New → Confirmed
Changed in nova:
assignee: nobody → Pranav Kant Gaur (pranavkg)

Due to http://git.openstack.org/cgit/openstack/nova/tree/doc/source/cells.rst?id=11019fab7a2415cbca8b93e9346b21327e79688d#n40 I would not expect this to be fixed. However it is useful to have this bug open for now for others who may search for the same failure.

Changed in nova:
importance: Medium → Wishlist
Andrew Laski (alaski) on 2016-04-18
Changed in nova:
assignee: Pranav Kant Gaur (pranavkg) → nobody

Has anyone checked whether this bug exists in Mitaka with Cells v2? If the issue is something in the RPC between parent and child cells then this is likely to stay broken till at least Newton (because most people running Cells already with be keeping a v1 parent in order to have multiple child Cells).

Daniel, as you authored the bulk of the NUMA functionality, do you have any idea why this is breaking with Cells?

John Garbutt (johngarbutt) wrote :

To be clear, cells v1 is hard feature and bug fix frozen right now, so this is not likely to get fixed.

Perhaps unsurprisingly, but for completeness, this also occurs when trying to use image properties instead of aggregate metadata.

Augustina Ragwitz (auggy) wrote :

I'm going to update the status of this bug as wontfix per comments regarding Cellsv1 freeze above. If you find further information that suggests this is unrelated to Cellsv1 then feel free to reopen this bug with that new information.

Changed in nova:
status: Confirmed → Won't Fix
summary: Can't create instances with flavors that have "numa" related extra specs
- in a cell setup
+ in a cell setup (cells v1)
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers